diff --git a/salt/modules/virt.py b/salt/modules/virt.py
index c8e046a47a..a78c21e323 100644
--- a/salt/modules/virt.py
+++ b/salt/modules/virt.py
@@ -2992,22 +3558,41 @@ def define_xml_path(path, **kwargs):
 
         salt '*' virt.define_xml_path <path to XML file on the node>
 
-    '''
+    """
     try:
-        with salt.utils.files.fopen(path, 'r') as fp_:
+        with salt.utils.files.fopen(path, "r") as fp_:
             return define_xml_str(
-                salt.utils.stringutils.to_unicode(fp_.read()),
-                **kwargs
+                salt.utils.stringutils.to_unicode(fp_.read()), **kwargs
             )
     except (OSError, IOError):
         return False
 
 
-def define_vol_xml_str(xml, **kwargs):  # pylint: disable=redefined-outer-name
-    '''
+def _define_vol_xml_str(conn, xml, pool=None):  # pylint: disable=redefined-outer-name
+    """
+    Same function than define_vml_xml_str but using an already opened libvirt connection
+    """
+    default_pool = "default" if conn.getType() != "ESX" else "0"
+    poolname = (
+        pool if pool else __salt__["config.get"]("virt:storagepool", default_pool)
+    )
+    pool = conn.storagePoolLookupByName(six.text_type(poolname))
+    ret = pool.createXML(xml, 0) is not None
+    return ret
+
+
+def define_vol_xml_str(
+    xml, pool=None, **kwargs
+):  # pylint: disable=redefined-outer-name
+    """
     Define a volume based on the XML passed to the function
 
     :param xml: libvirt XML definition of the storage volume
+    :param pool:
+        storage pool name to define the volume in.
+        If defined, this parameter will override the configuration setting.
+
+        .. versionadded:: Sodium
     :param connection: libvirt connection URI, overriding defaults
 
         .. versionadded:: 2019.2.0
@@ -3025,36 +3610,34 @@ def define_vol_xml_str(xml, **kwargs):  # pylint: disable=redefined-outer-name
         salt '*' virt.define_vol_xml_str <XML in string format>
 
     The storage pool where the disk image will be defined is ``default``
-    unless changed with a configuration like this:
+    unless changed with the pool parameter or a configuration like this:
 
     .. code-block:: yaml
 
         virt:
             storagepool: mine
-    '''
-    poolname = __salt__['config.get']('libvirt:storagepool', None)
-    if poolname is not None:
-        salt.utils.versions.warn_until(
-            'Sodium',
-            '\'libvirt:storagepool\' has been deprecated in favor of '
-            '\'virt:storagepool\'. \'libvirt:storagepool\' will stop '
-            'being used in {version}.'
-        )
-    else:
-        poolname = __salt__['config.get']('virt:storagepool', 'default')
-
+    """
     conn = __get_conn(**kwargs)
-    pool = conn.storagePoolLookupByName(six.text_type(poolname))
-    ret = pool.createXML(xml, 0) is not None
-    conn.close()
+    ret = False
+    try:
+        ret = _define_vol_xml_str(conn, xml, pool=pool)
+    except libvirtError as err:
+        raise CommandExecutionError(err.get_error_message())
+    finally:
+        conn.close()
     return ret
 
 
-def define_vol_xml_path(path, **kwargs):
-    '''
+def define_vol_xml_path(path, pool=None, **kwargs):
+    """
     Define a volume based on the XML-file path passed to the function
 
     :param path: path to a file containing the libvirt XML definition of the volume
+    :param pool:
+        storage pool name to define the volume in.
+        If defined, this parameter will override the configuration setting.
+
+        .. versionadded:: Sodium
     :param connection: libvirt connection URI, overriding defaults
 
         .. versionadded:: 2019.2.0
@@ -3071,19 +3654,18 @@ def define_vol_xml_path(path, **kwargs):
 
         salt '*' virt.define_vol_xml_path <path to XML file on the node>
 
-    '''
+    """
     try:
-        with salt.utils.files.fopen(path, 'r') as fp_:
+        with salt.utils.files.fopen(path, "r") as fp_:
             return define_vol_xml_str(
-                salt.utils.stringutils.to_unicode(fp_.read()),
-                **kwargs
+                salt.utils.stringutils.to_unicode(fp_.read()), pool=pool, **kwargs
             )
     except (OSError, IOError):
         return False
 
 
 def migrate_non_shared(vm_, target, ssh=False):
-    '''
+    """
     Attempt to execute non-shared storage "all" migration
 
     :param vm_: domain name
@@ -3106,18 +3688,17 @@ def migrate_non_shared(vm_, target, ssh=False):
 
     For more details on tunnelled data migrations, report to
     https://libvirt.org/migration.html#transporttunnel
-    '''
-    cmd = _get_migrate_command() + ' --copy-storage-all ' + vm_\
-        + _get_target(target, ssh)
+    """
+    cmd = (
+        _get_migrate_command() + " --copy-storage-all " + vm_ + _get_target(target, ssh)
+    )
 
-    stdout = subprocess.Popen(cmd,
-                              shell=True,
-                              stdout=subprocess.PIPE).communicate()[0]
+    stdout = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE).communicate()[0]
     return salt.utils.stringutils.to_str(stdout)
 
 
 def migrate_non_shared_inc(vm_, target, ssh=False):
-    '''
+    """
     Attempt to execute non-shared storage "all" migration
 
     :param vm_: domain name
@@ -3140,18 +3721,17 @@ def migrate_non_shared_inc(vm_, target, ssh=False):
 
     For more details on tunnelled data migrations, report to
     https://libvirt.org/migration.html#transporttunnel
-    '''
-    cmd = _get_migrate_command() + ' --copy-storage-inc ' + vm_\
-        + _get_target(target, ssh)
+    """
+    cmd = (
+        _get_migrate_command() + " --copy-storage-inc " + vm_ + _get_target(target, ssh)
+    )
 
-    stdout = subprocess.Popen(cmd,
-                              shell=True,
-                              stdout=subprocess.PIPE).communicate()[0]
+    stdout = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE).communicate()[0]
     return salt.utils.stringutils.to_str(stdout)
 
 
 def migrate(vm_, target, ssh=False):
-    '''
+    """
     Shared storage migration
 
     :param vm_: domain name
@@ -3174,18 +3754,15 @@ def migrate(vm_, target, ssh=False):
 
     For more details on tunnelled data migrations, report to
     https://libvirt.org/migration.html#transporttunnel
-    '''
-    cmd = _get_migrate_command() + ' ' + vm_\
-        + _get_target(target, ssh)
+    """
+    cmd = _get_migrate_command() + " " + vm_ + _get_target(target, ssh)
 
-    stdout = subprocess.Popen(cmd,
-                              shell=True,
-                              stdout=subprocess.PIPE).communicate()[0]
+    stdout = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE).communicate()[0]
     return salt.utils.stringutils.to_str(stdout)
 
 
 def seed_non_shared_migrate(disks, force=False):
-    '''
+    """
     Non shared migration requires that the disks be present on the migration
     destination, pass the disks information via this function, to the
     migration destination before executing the migration.
@@ -3199,33 +3776,37 @@ def seed_non_shared_migrate(disks, force=False):
     .. code-block:: bash
 
         salt '*' virt.seed_non_shared_migrate <disks>
-    '''
+    """
     for _, data in six.iteritems(disks):
-        fn_ = data['file']
-        form = data['file format']
-        size = data['virtual size'].split()[1][1:]
+        fn_ = data["file"]
+        form = data["file format"]
+        size = data["virtual size"].split()[1][1:]
         if os.path.isfile(fn_) and not force:
             # the target exists, check to see if it is compatible
-            pre = salt.utils.yaml.safe_load(subprocess.Popen('qemu-img info arch',
-                                                             shell=True,
-                                                             stdout=subprocess.PIPE).communicate()[0])
-            if pre['file format'] != data['file format']\
-                    and pre['virtual size'] != data['virtual size']:
+            pre = salt.utils.yaml.safe_load(
+                subprocess.Popen(
+                    "qemu-img info arch", shell=True, stdout=subprocess.PIPE
+                ).communicate()[0]
+            )
+            if (
+                pre["file format"] != data["file format"]
+                and pre["virtual size"] != data["virtual size"]
+            ):
                 return False
         if not os.path.isdir(os.path.dirname(fn_)):
             os.makedirs(os.path.dirname(fn_))
         if os.path.isfile(fn_):
             os.remove(fn_)
-        cmd = 'qemu-img create -f ' + form + ' ' + fn_ + ' ' + size
+        cmd = "qemu-img create -f " + form + " " + fn_ + " " + size
         subprocess.call(cmd, shell=True)
         creds = _libvirt_creds()
-        cmd = 'chown ' + creds['user'] + ':' + creds['group'] + ' ' + fn_
+        cmd = "chown " + creds["user"] + ":" + creds["group"] + " " + fn_
         subprocess.call(cmd, shell=True)
     return True
 
 
-def set_autostart(vm_, state='on', **kwargs):
-    '''
+def set_autostart(vm_, state="on", **kwargs):
+    """
     Set the autostart flag on a VM so that the VM will start with the host
     system on reboot.
 
@@ -3247,17 +3828,17 @@ def set_autostart(vm_, state='on', **kwargs):
     .. code-block:: bash
 
         salt "*" virt.set_autostart <domain> <on | off>
-    '''
+    """
     conn = __get_conn(**kwargs)
     dom = _get_domain(conn, vm_)
 
     # return False if state is set to something other then on or off
     ret = False
 
-    if state == 'on':
+    if state == "on":
         ret = dom.setAutostart(1) == 0
 
-    elif state == 'off':
+    elif state == "off":
         ret = dom.setAutostart(0) == 0
 
     conn.close()
@@ -3265,7 +3846,7 @@ def set_autostart(vm_, state='on', **kwargs):
 
 
 def undefine(vm_, **kwargs):
-    '''
+    """
     Remove a defined vm, this does not purge the virtual machine image, and
     this only works if the vm is powered down
 
@@ -3285,10 +3866,10 @@ def undefine(vm_, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.undefine <domain>
-    '''
+    """
     conn = __get_conn(**kwargs)
     dom = _get_domain(conn, vm_)
-    if getattr(libvirt, 'VIR_DOMAIN_UNDEFINE_NVRAM', False):
+    if getattr(libvirt, "VIR_DOMAIN_UNDEFINE_NVRAM", False):
         # This one is only in 1.2.8+
         ret = dom.undefineFlags(libvirt.VIR_DOMAIN_UNDEFINE_NVRAM) == 0
     else:
@@ -3297,16 +3878,12 @@ def undefine(vm_, **kwargs):
     return ret
 
 
-def purge(vm_, dirs=False, removables=None, **kwargs):
-    '''
+def purge(vm_, dirs=False, removables=False, **kwargs):
+    """
     Recursively destroy and delete a persistent virtual machine, pass True for
     dir's to also delete the directories containing the virtual machine disk
     images - USE WITH EXTREME CAUTION!
 
-    Pass removables=False to avoid deleting cdrom and floppy images. To avoid
-    disruption, the default but dangerous value is True. This will be changed
-    to the safer False default value in Sodium.
-
     :param vm_: domain name
     :param dirs: pass True to remove containing directories
     :param removables: pass True to remove removable devices
@@ -3326,31 +3903,46 @@ def purge(vm_, dirs=False, removables=None, **kwargs):
 
     .. code-block:: bash
 
-        salt '*' virt.purge <domain> removables=False
-    '''
+        salt '*' virt.purge <domain>
+    """
     conn = __get_conn(**kwargs)
     dom = _get_domain(conn, vm_)
-    disks = _get_disks(dom)
-    if removables is None:
-        salt.utils.versions.warn_until(
-            'Sodium',
-            'removables argument default value is True, but will be changed '
-            'to False by default in {version}. Please set to True to maintain '
-            'the current behavior in the future.'
-        )
-        removables = True
-    if VIRT_STATE_NAME_MAP.get(dom.info()[0], 'unknown') != 'shutdown' and dom.destroy() != 0:
+    disks = _get_disks(conn, dom)
+    if (
+        VIRT_STATE_NAME_MAP.get(dom.info()[0], "unknown") != "shutdown"
+        and dom.destroy() != 0
+    ):
         return False
     directories = set()
     for disk in disks:
-        if not removables and disks[disk]['type'] in ['cdrom', 'floppy']:
+        if not removables and disks[disk]["type"] in ["cdrom", "floppy"]:
             continue
-        os.remove(disks[disk]['file'])
-        directories.add(os.path.dirname(disks[disk]['file']))
+        if disks[disk].get("zfs", False):
+            # TODO create solution for 'dataset is busy'
+            time.sleep(3)
+            fs_name = disks[disk]["file"][len("/dev/zvol/") :]
+            log.info("Destroying VM ZFS volume {0}".format(fs_name))
+            __salt__["zfs.destroy"](name=fs_name, force=True)
+        elif os.path.exists(disks[disk]["file"]):
+            os.remove(disks[disk]["file"])
+            directories.add(os.path.dirname(disks[disk]["file"]))
+        else:
+            # We may have a volume to delete here
+            matcher = re.match("^(?P<pool>[^/]+)/(?P<volume>.*)$", disks[disk]["file"],)
+            if matcher:
+                pool_name = matcher.group("pool")
+                pool = None
+                if pool_name in conn.listStoragePools():
+                    pool = conn.storagePoolLookupByName(pool_name)
+
+                if pool and matcher.group("volume") in pool.listVolumes():
+                    volume = pool.storageVolLookupByName(matcher.group("volume"))
+                    volume.delete()
+
     if dirs:
         for dir_ in directories:
             shutil.rmtree(dir_)
-    if getattr(libvirt, 'VIR_DOMAIN_UNDEFINE_NVRAM', False):
+    if getattr(libvirt, "VIR_DOMAIN_UNDEFINE_NVRAM", False):
         # This one is only in 1.2.8+
         try:
             dom.undefineFlags(libvirt.VIR_DOMAIN_UNDEFINE_NVRAM)
@@ -3363,7 +3955,7 @@ def purge(vm_, dirs=False, removables=None, **kwargs):
 
 
 def virt_type():
-    '''
+    """
     Returns the virtual machine type as a string
 
     CLI Example:
@@ -3371,92 +3963,53 @@ def virt_type():
     .. code-block:: bash
 
         salt '*' virt.virt_type
-    '''
-    return __grains__['virtual']
+    """
+    return __grains__["virtual"]
 
 
 def _is_kvm_hyper():
-    '''
+    """
     Returns a bool whether or not this node is a KVM hypervisor
-    '''
+    """
     try:
-        with salt.utils.files.fopen('/proc/modules') as fp_:
-            if 'kvm_' not in salt.utils.stringutils.to_unicode(fp_.read()):
+        with salt.utils.files.fopen("/proc/modules") as fp_:
+            if "kvm_" not in salt.utils.stringutils.to_unicode(fp_.read()):
                 return False
     except IOError:
         # No /proc/modules? Are we on Windows? Or Solaris?
         return False
-    return 'libvirtd' in __salt__['cmd.run'](__grains__['ps'])
-
-
-def is_kvm_hyper():
-    '''
-    Returns a bool whether or not this node is a KVM hypervisor
-
-    CLI Example:
-
-    .. code-block:: bash
-
-        salt '*' virt.is_kvm_hyper
-
-    .. deprecated:: 2019.2.0
-    '''
-    salt.utils.versions.warn_until(
-        'Sodium',
-        '\'is_kvm_hyper\' function has been deprecated. Use the \'get_hypervisor\' == "kvm" instead. '
-        '\'is_kvm_hyper\' will be removed in {version}.'
-    )
-    return _is_kvm_hyper()
+    return "libvirtd" in __salt__["cmd.run"](__grains__["ps"])
 
 
 def _is_xen_hyper():
-    '''
+    """
     Returns a bool whether or not this node is a XEN hypervisor
-    '''
+    """
     try:
-        if __grains__['virtual_subtype'] != 'Xen Dom0':
+        if __grains__["virtual_subtype"] != "Xen Dom0":
             return False
     except KeyError:
         # virtual_subtype isn't set everywhere.
         return False
     try:
-        with salt.utils.files.fopen('/proc/modules') as fp_:
-            if 'xen_' not in salt.utils.stringutils.to_unicode(fp_.read()):
+        with salt.utils.files.fopen("/proc/modules") as fp_:
+            if "xen_" not in salt.utils.stringutils.to_unicode(fp_.read()):
                 return False
     except (OSError, IOError):
         # No /proc/modules? Are we on Windows? Or Solaris?
         return False
-    return 'libvirtd' in __salt__['cmd.run'](__grains__['ps'])
-
-
-def is_xen_hyper():
-    '''
-    Returns a bool whether or not this node is a XEN hypervisor
-
-    CLI Example:
-
-    .. code-block:: bash
-
-        salt '*' virt.is_xen_hyper
-
-    .. deprecated:: 2019.2.0
-    '''
-    salt.utils.versions.warn_until(
-        'Sodium',
-        '\'is_xen_hyper\' function has been deprecated. Use the \'get_hypervisor\' == "xen" instead. '
-        '\'is_xen_hyper\' will be removed in {version}.'
-    )
-    return _is_xen_hyper()
+    return "libvirtd" in __salt__["cmd.run"](__grains__["ps"])
 
 
 def get_hypervisor():
-    '''
+    """
     Returns the name of the hypervisor running on this node or ``None``.
 
     Detected hypervisors:
 
     - kvm
     - xen
+    - bhyve
 
     CLI Example:
 
@@ -3465,17 +4018,34 @@ def get_hypervisor():
         salt '*' virt.get_hypervisor
 
     .. versionadded:: 2019.2.0
-        the function and the ``kvm`` and ``xen`` hypervisors support
-    '''
+        the function and the ``kvm``, ``xen`` and ``bhyve`` hypervisors support
+    """
     # To add a new 'foo' hypervisor, add the _is_foo_hyper function,
     # add 'foo' to the list below and add it to the docstring with a .. versionadded::
-    hypervisors = ['kvm', 'xen']
-    result = [hyper for hyper in hypervisors if getattr(sys.modules[__name__], '_is_{}_hyper'.format(hyper))()]
+    hypervisors = ["kvm", "xen", "bhyve"]
+    result = [
+        hyper
+        for hyper in hypervisors
+        if getattr(sys.modules[__name__], "_is_{}_hyper".format(hyper))()
+    ]
     return result[0] if result else None
 
 
+def _is_bhyve_hyper():
+    sysctl_cmd = "sysctl hw.vmm.create"
+    vmm_enabled = False
+    try:
+        stdout = subprocess.Popen(
+            sysctl_cmd, shell=True, stdout=subprocess.PIPE
+        ).communicate()[0]
+        vmm_enabled = len(salt.utils.stringutils.to_str(stdout).split('"')[1]) != 0
+    except IndexError:
+        pass
+    return vmm_enabled
+
+
 def is_hyper():
-    '''
+    """
     Returns a bool whether or not this node is a hypervisor of any kind
 
     CLI Example:
@@ -3483,14 +4053,14 @@ def is_hyper():
     .. code-block:: bash
 
         salt '*' virt.is_hyper
-    '''
+    """
     if HAS_LIBVIRT:
-        return is_xen_hyper() or is_kvm_hyper()
+        return _is_xen_hyper() or _is_kvm_hyper() or _is_bhyve_hyper()
     return False
 
 
 def vm_cputime(vm_=None, **kwargs):
-    '''
+    """
     Return cputime used by the vms on this hyper in a
     list of dicts:
 
@@ -3523,14 +4093,14 @@ def vm_cputime(vm_=None, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.vm_cputime
-    '''
+    """
     conn = __get_conn(**kwargs)
     host_cpus = conn.getInfo()[2]
 
     def _info(dom):
-        '''
+        """
         Compute cputime info of a domain
-        '''
+        """
         raw = dom.info()
         vcpus = int(raw[3])
         cputime = int(raw[4])
@@ -3539,9 +4109,10 @@ def vm_cputime(vm_=None, **kwargs):
             # Divide by vcpus to always return a number between 0 and 100
             cputime_percent = (1.0e-7 * cputime / host_cpus) / vcpus
         return {
-                'cputime': int(raw[4]),
-                'cputime_percent': int('{0:.0f}'.format(cputime_percent))
-               }
+            "cputime": int(raw[4]),
+            "cputime_percent": int("{0:.0f}".format(cputime_percent)),
+        }
+
     info = {}
     if vm_:
         info[vm_] = _info(_get_domain(conn, vm_))
@@ -3553,7 +4124,7 @@ def vm_cputime(vm_=None, **kwargs):
 
 
 def vm_netstats(vm_=None, **kwargs):
-    '''
+    """
     Return combined network counters used by the vms on this hyper in a
     list of dicts:
 
@@ -3592,36 +4163,38 @@ def vm_netstats(vm_=None, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.vm_netstats
-    '''
+    """
+
     def _info(dom):
-        '''
+        """
         Compute network stats of a domain
-        '''
+        """
         nics = _get_nics(dom)
         ret = {
-                'rx_bytes': 0,
-                'rx_packets': 0,
-                'rx_errs': 0,
-                'rx_drop': 0,
-                'tx_bytes': 0,
-                'tx_packets': 0,
-                'tx_errs': 0,
-                'tx_drop': 0
-               }
+            "rx_bytes": 0,
+            "rx_packets": 0,
+            "rx_errs": 0,
+            "rx_drop": 0,
+            "tx_bytes": 0,
+            "tx_packets": 0,
+            "tx_errs": 0,
+            "tx_drop": 0,
+        }
         for attrs in six.itervalues(nics):
-            if 'target' in attrs:
-                dev = attrs['target']
+            if "target" in attrs:
+                dev = attrs["target"]
                 stats = dom.interfaceStats(dev)
-                ret['rx_bytes'] += stats[0]
-                ret['rx_packets'] += stats[1]
-                ret['rx_errs'] += stats[2]
-                ret['rx_drop'] += stats[3]
-                ret['tx_bytes'] += stats[4]
-                ret['tx_packets'] += stats[5]
-                ret['tx_errs'] += stats[6]
-                ret['tx_drop'] += stats[7]
+                ret["rx_bytes"] += stats[0]
+                ret["rx_packets"] += stats[1]
+                ret["rx_errs"] += stats[2]
+                ret["rx_drop"] += stats[3]
+                ret["tx_bytes"] += stats[4]
+                ret["tx_packets"] += stats[5]
+                ret["tx_errs"] += stats[6]
+                ret["tx_drop"] += stats[7]
 
         return ret
+
     info = {}
     conn = __get_conn(**kwargs)
     if vm_:
@@ -3634,7 +4207,7 @@ def vm_netstats(vm_=None, **kwargs):
 
 
 def vm_diskstats(vm_=None, **kwargs):
-    '''
+    """
     Return disk usage counters used by the vms on this hyper in a
     list of dicts:
 
@@ -3670,36 +4243,33 @@ def vm_diskstats(vm_=None, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.vm_blockstats
-    '''
+    """
+
     def get_disk_devs(dom):
-        '''
+        """
         Extract the disk devices names from the domain XML definition
-        '''
+        """
         doc = ElementTree.fromstring(get_xml(dom, **kwargs))
-        return [target.get('dev') for target in doc.findall('devices/disk/target')]
+        return [target.get("dev") for target in doc.findall("devices/disk/target")]
 
     def _info(dom):
-        '''
+        """
         Compute the disk stats of a domain
-        '''
+        """
         # Do not use get_disks, since it uses qemu-img and is very slow
         # and unsuitable for any sort of real time statistics
         disks = get_disk_devs(dom)
-        ret = {'rd_req': 0,
-               'rd_bytes': 0,
-               'wr_req': 0,
-               'wr_bytes': 0,
-               'errs': 0
-               }
+        ret = {"rd_req": 0, "rd_bytes": 0, "wr_req": 0, "wr_bytes": 0, "errs": 0}
         for disk in disks:
             stats = dom.blockStats(disk)
-            ret['rd_req'] += stats[0]
-            ret['rd_bytes'] += stats[1]
-            ret['wr_req'] += stats[2]
-            ret['wr_bytes'] += stats[3]
-            ret['errs'] += stats[4]
+            ret["rd_req"] += stats[0]
+            ret["rd_bytes"] += stats[1]
+            ret["wr_req"] += stats[2]
+            ret["wr_bytes"] += stats[3]
+            ret["errs"] += stats[4]
 
         return ret
+
     info = {}
     conn = __get_conn(**kwargs)
     if vm_:
@@ -3713,30 +4283,33 @@ def vm_diskstats(vm_=None, **kwargs):
 
 
 def _parse_snapshot_description(vm_snapshot, unix_time=False):
-    '''
+    """
     Parse XML doc and return a dict with the status values.
 
     :param xmldoc:
     :return:
-    '''
+    """
     ret = dict()
     tree = ElementTree.fromstring(vm_snapshot.getXMLDesc())
     for node in tree:
-        if node.tag == 'name':
-            ret['name'] = node.text
-        elif node.tag == 'creationTime':
-            ret['created'] = datetime.datetime.fromtimestamp(float(node.text)).isoformat(' ') \
-                                if not unix_time else float(node.text)
-        elif node.tag == 'state':
-            ret['running'] = node.text == 'running'
+        if node.tag == "name":
+            ret["name"] = node.text
+        elif node.tag == "creationTime":
+            ret["created"] = (
+                datetime.datetime.fromtimestamp(float(node.text)).isoformat(" ")
+                if not unix_time
+                else float(node.text)
+            )
+        elif node.tag == "state":
+            ret["running"] = node.text == "running"
 
-    ret['current'] = vm_snapshot.isCurrent() == 1
+    ret["current"] = vm_snapshot.isCurrent() == 1
 
     return ret
 
 
 def list_snapshots(domain=None, **kwargs):
-    '''
+    """
     List available snapshots for certain vm or for all.
 
     :param domain: domain name
@@ -3758,18 +4331,20 @@ def list_snapshots(domain=None, **kwargs):
 
         salt '*' virt.list_snapshots
         salt '*' virt.list_snapshots <domain>
-    '''
+    """
     ret = dict()
     conn = __get_conn(**kwargs)
     for vm_domain in _get_domain(conn, *(domain and [domain] or list()), iterable=True):
-        ret[vm_domain.name()] = [_parse_snapshot_description(snap) for snap in vm_domain.listAllSnapshots()] or 'N/A'
+        ret[vm_domain.name()] = [
+            _parse_snapshot_description(snap) for snap in vm_domain.listAllSnapshots()
+        ] or "N/A"
 
     conn.close()
     return ret
 
 
 def snapshot(domain, name=None, suffix=None, **kwargs):
-    '''
+    """
     Create a snapshot of a VM.
 
     :param domain: domain name
@@ -3795,18 +4370,22 @@ def snapshot(domain, name=None, suffix=None, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.snapshot <domain>
-    '''
+    """
     if name and name.lower() == domain.lower():
-        raise CommandExecutionError('Virtual Machine {name} is already defined. '
-                                    'Please choose another name for the snapshot'.format(name=name))
+        raise CommandExecutionError(
+            "Virtual Machine {name} is already defined. "
+            "Please choose another name for the snapshot".format(name=name)
+        )
     if not name:
-        name = "{domain}-{tsnap}".format(domain=domain, tsnap=time.strftime('%Y%m%d-%H%M%S', time.localtime()))
+        name = "{domain}-{tsnap}".format(
+            domain=domain, tsnap=time.strftime("%Y%m%d-%H%M%S", time.localtime())
+        )
 
     if suffix:
         name = "{name}-{suffix}".format(name=name, suffix=suffix)
 
-    doc = ElementTree.Element('domainsnapshot')
-    n_name = ElementTree.SubElement(doc, 'name')
+    doc = ElementTree.Element("domainsnapshot")
+    n_name = ElementTree.SubElement(doc, "name")
     n_name.text = name
 
     conn = __get_conn(**kwargs)
@@ -3815,11 +4394,11 @@ def snapshot(domain, name=None, suffix=None, **kwargs):
     )
     conn.close()
 
-    return {'name': name}
+    return {"name": name}
 
 
 def delete_snapshots(name, *names, **kwargs):
-    '''
+    """
     Delete one or more snapshots of the given VM.
 
     :param name: domain name
@@ -3843,7 +4422,7 @@ def delete_snapshots(name, *names, **kwargs):
         salt '*' virt.delete_snapshots <domain> all=True
         salt '*' virt.delete_snapshots <domain> <snapshot>
         salt '*' virt.delete_snapshots <domain> <snapshot1> <snapshot2> ...
-    '''
+    """
     deleted = dict()
     conn = __get_conn(**kwargs)
     domain = _get_domain(conn, name)
@@ -3853,13 +4432,16 @@ def delete_snapshots(name, *names, **kwargs):
             snap.delete()
     conn.close()
 
-    available = {name: [_parse_snapshot_description(snap) for snap in domain.listAllSnapshots()] or 'N/A'}
+    available = {
+        name: [_parse_snapshot_description(snap) for snap in domain.listAllSnapshots()]
+        or "N/A"
+    }
 
-    return {'available': available, 'deleted': deleted}
+    return {"available": available, "deleted": deleted}
 
 
 def revert_snapshot(name, vm_snapshot=None, cleanup=False, **kwargs):
-    '''
+    """
     Revert snapshot to the previous from current (if available) or to the specific.
 
     :param name: domain name
@@ -3883,7 +4465,7 @@ def revert_snapshot(name, vm_snapshot=None, cleanup=False, **kwargs):
 
         salt '*' virt.revert <domain>
         salt '*' virt.revert <domain> <snapshot>
-    '''
+    """
     ret = dict()
     conn = __get_conn(**kwargs)
     domain = _get_domain(conn, name)
@@ -3891,22 +4473,32 @@ def revert_snapshot(name, vm_snapshot=None, cleanup=False, **kwargs):
 
     _snapshots = list()
     for snap_obj in snapshots:
-        _snapshots.append({'idx': _parse_snapshot_description(snap_obj, unix_time=True)['created'], 'ptr': snap_obj})
-    snapshots = [w_ptr['ptr'] for w_ptr in sorted(_snapshots, key=lambda item: item['idx'], reverse=True)]
+        _snapshots.append(
+            {
+                "idx": _parse_snapshot_description(snap_obj, unix_time=True)["created"],
+                "ptr": snap_obj,
+            }
+        )
+    snapshots = [
+        w_ptr["ptr"]
+        for w_ptr in sorted(_snapshots, key=lambda item: item["idx"], reverse=True)
+    ]
     del _snapshots
 
     if not snapshots:
         conn.close()
-        raise CommandExecutionError('No snapshots found')
+        raise CommandExecutionError("No snapshots found")
     elif len(snapshots) == 1:
         conn.close()
-        raise CommandExecutionError('Cannot revert to itself: only one snapshot is available.')
+        raise CommandExecutionError(
+            "Cannot revert to itself: only one snapshot is available."
+        )
 
     snap = None
     for p_snap in snapshots:
         if not vm_snapshot:
-            if p_snap.isCurrent() and snapshots[snapshots.index(p_snap) + 1:]:
-                snap = snapshots[snapshots.index(p_snap) + 1:][0]
+            if p_snap.isCurrent() and snapshots[snapshots.index(p_snap) + 1 :]:
+                snap = snapshots[snapshots.index(p_snap) + 1 :][0]
                 break
         elif p_snap.getName() == vm_snapshot:
             snap = p_snap
@@ -3915,13 +4507,16 @@ def revert_snapshot(name, vm_snapshot=None, cleanup=False, **kwargs):
     if not snap:
         conn.close()
         raise CommandExecutionError(
-            snapshot and 'Snapshot "{0}" not found'.format(vm_snapshot) or 'No more previous snapshots available')
+            snapshot
+            and 'Snapshot "{0}" not found'.format(vm_snapshot)
+            or "No more previous snapshots available"
+        )
     elif snap.isCurrent():
         conn.close()
-        raise CommandExecutionError('Cannot revert to the currently running snapshot.')
+        raise CommandExecutionError("Cannot revert to the currently running snapshot.")
 
     domain.revertToSnapshot(snap)
-    ret['reverted'] = snap.getName()
+    ret["reverted"] = snap.getName()
 
     if cleanup:
         delete = list()
@@ -3931,9 +4526,9 @@ def revert_snapshot(name, vm_snapshot=None, cleanup=False, **kwargs):
                 p_snap.delete()
             else:
                 break
-        ret['deleted'] = delete
+        ret["deleted"] = delete
     else:
-        ret['deleted'] = 'N/A'
+        ret["deleted"] = "N/A"
 
     conn.close()
 
@@ -3941,12 +4536,12 @@ def revert_snapshot(name, vm_snapshot=None, cleanup=False, **kwargs):
 
 
 def _caps_add_machine(machines, node):
-    '''
+    """
     Parse the <machine> element of the host capabilities and add it
     to the machines list.
-    '''
-    maxcpus = node.get('maxCpus')
-    canonical = node.get('canonical')
+    """
+    maxcpus = node.get("maxCpus")
+    canonical = node.get("canonical")
     name = node.text
 
     alternate_name = ""
